/*
TODBC.CPP Direct ODBC Access Class, V1.00 21/6/2002
(C) 2002 Copyright By Fred Houweling. fred@fh.dropbear.id.au
All Rights Reserved
No Warranty, Use at your own risk, Don't blame me.

You may use/modify this code in any application you like even comercial
with no restrictions.
All I ask is for you to send me an email to let me know you found it of use.
Please remember this is all supplied Free of charge so please keep that
in mind if you ask me something.
This is still an early version and will be developed further.
Look for lates version at http://www.fh.dropbear.id.au/r/c
*/
#include "TODBC.h"

#include <string.h>
#include <stdio.h>
#include <mem.h>

/* Please note sql.h includes a file called sqltypes.h
This file contains the following code (At line 29 in my version)
//#ifdef WIN32
//#define SQL_API  __stdcall
//#else
//#define SQL_API
//#endif

It needs to be altered as bellow for this Class library to work
//#ifdef WIN32
//#define SQL_API  __stdcall
//#elif defined(__BORLANDC__)
//#define SQL_API  __stdcall
//#else
//#define SQL_API
//#endif

(No don't just define WIN32 as this has undesired consequences)

Also you will need to create a import library for odbc32.dll by doing the following.
implib -c odbc32.lib odbc32.dll

If you do not do all of the above this way you will end up with Stack problems.
*/
__fastcall TSQLDirect::TSQLDirect(void)
{
        henv=NULL;
        hdbc=NULL;
        hstmt=NULL;
        dsn=NULL;
        user=NULL;
        passwd=NULL;

        retcode=0;
        connected=false;
        error=0;
        timeout=5;
}
__fastcall TSQLDirect::~TSQLDirect(void)
{
        if(dsn!=NULL)
        {
                memset(dsn, 0x0, strlen(dsn)); // Security Precaution
                delete[] dsn;
        }
        if(user!=NULL)
        {
                memset(user, 0x0, strlen(user)); // Security Precaution
                delete[] user;
        }
        if(passwd!=NULL)
        {
                memset(passwd, 0x0, strlen(passwd)); // Security Precaution
                delete[] passwd;
        }
        if(connected==true)
                ODBCDisconnect();
        henv=NULL;
        hdbc=NULL;
        hstmt=NULL;
        dsn=NULL;
        user=NULL;
        passwd=NULL;

        retcode=0;
        connected=false;
        error=0;
        timeout=5;
}
int __fastcall TSQLDirect::ODBCSetUserName(char *USER)
{
        if(user!=NULL)
                delete[] user;
        if(USER==NULL)
        {
                user=NULL;
                return(true);
        }
        user=new char [strlen(USER)+1];
        if(user!=NULL) // Allocation did not fail
                strcpy(user, USER);
        else
                return(false);
        return(true);
}
int __fastcall TSQLDirect::ODBCSetPassword(char *PASSWORD)
{
        if(passwd!=NULL)
                delete[] passwd;
        if(PASSWORD==NULL)
        {
                passwd=NULL;
                return(true);
        }
        passwd=new char [strlen(PASSWORD)+1];
        if(passwd!=NULL)
                strcpy(passwd, PASSWORD);
        else
                return(false);
        return(true);
}
int __fastcall TSQLDirect::ODBCSetDSN(char *DSN)
{
        if(dsn!=NULL)
                delete[] dsn;
        if(DSN==NULL)
        {
                dsn=NULL;
                return(true);
        }
        dsn=new char [strlen(DSN)+1];
        if(dsn!=NULL)
                strcpy(dsn, DSN);
        else
                return(false);
        return(true);
}
int __fastcall TSQLDirect::ODBCConnect(void)
{
        retcode = SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &henv);
        if (retcode != SQL_SUCCESS && retcode == SQL_SUCCESS_WITH_INFO)
        {
                error=1;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }
        /* Set the ODBC version environment attribute */
        retcode = SQLSetEnvAttr(henv, SQL_ATTR_ODBC_VERSION, (void*)SQL_OV_ODBC3, 0);
        if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
        {
                retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
                error=2;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }
        /* Allocate connection handle */
        retcode = SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc);
        if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
        {
                retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
                error=3;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }
        /* Set login timeout in seconds. */
        retcode = SQLSetConnectAttr(hdbc, SQL_LOGIN_TIMEOUT, (void *)timeout, 0);
        if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
        {
                retcode = SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
                retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
                error=4;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }
        retcode = SQLConnect(hdbc, dsn, SQL_NTS, user, SQL_NTS, passwd, SQL_NTS);
        if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
        {
                retcode = SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
                retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
                error=5;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }

        /* Allocate statement handle */
        retcode = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
        if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
        {
                retcode = SQLDisconnect(hdbc);
                retcode = SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
                retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
                error=6;
                hstmt=NULL;
                hdbc=NULL;
                henv=NULL;
                connected=false;
                return(false);
        }
        error=0;
        connected=true;
        return(true);
}
int __fastcall TSQLDirect::ODBCDisconnect(void)
{
        retcode = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
        retcode = SQLDisconnect(hdbc);
        retcode = SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
        retcode = SQLFreeHandle(SQL_HANDLE_ENV, henv);
        hstmt=NULL;
        hdbc=NULL;
        henv=NULL;
        connected=false;
        return(true);
}

int __fastcall TSQLDirect::ODBCExecDirect(char *string)
{
        if(connected!=true) // For the Laze programmer
                ODBCConnect();
        if(connected==true)
        {
                retcode = SQLExecDirect(hstmt, string, SQL_NTS);
                retcode = SQLEndTran(SQL_HANDLE_DBC,hdbc,SQL_COMMIT);
                return(true);
        }
        return(false);
}